(function() {
  var express, fs, http;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  express = require('express');
  http = require('http');
  fs = require('fs');
  this.serve = function(engine, port) {
    var path;
    if (engine == null) {
      engine = 'coffee';
    }
    if (port == null) {
      port = 5678;
    }
    this.server = express.createServer();
    this.server.register('.coffee', require('coffeekup'));
    this.server.set('views', "" + (process.cwd()) + "/views");
    this.server.set('view engine', engine);
    this.server.set('view options', {
      layout: false
    });
    this.server.configure(__bind(function() {
      this.server.use(express.static("" + (process.cwd()) + "/public"));
      this.server.use(express.bodyParser());
      return this.server.use(express.cookieParser());
    }, this));
    this.server.configure('development', __bind(function() {
      return this.server.use(express.errorHandler({
        dumpExceptions: true,
        showStack: true
      }));
    }, this));
    this.server.configure('production', __bind(function() {
      return this.server.use(express.errorHandler());
    }, this));
    path = "" + (process.cwd()) + "/timbits";
    fs.readdir(path, __bind(function(err, files) {
      var file, name, _i, _len, _results;
      if (err) {
        throw err;
      }
      _results = [];
      for (_i = 0, _len = files.length; _i < _len; _i++) {
        file = files[_i];
        name = file.replace('.coffee', '');
        _results.push(this.add(name, require("" + path + "/" + name)));
      }
      return _results;
    }, this));
    this.server.listen(port);
    console.log("Timbits server listening on port " + (this.server.address().port) + " in " + this.server.settings.env + " mode");
    return this.server;
  };
  this.box = {};
  this.add = function(name, timbit) {
    console.log("\t Placing " + name + " in the box");
    timbit.name = name;
    this.box[name] = timbit;
    return this.server.get(timbit.route || ("/" + name + "/:view?"), function(req, res) {
      var context, _base, _ref;
      context = {
        name: name,
        view: (_ref = (_base = req.params).view) != null ? _ref : _base.view = 'default',
        request: req,
        response: res
      };
      return timbit.eat(context);
    });
  };
  this.Timbit = (function() {
    function Timbit() {}
    Timbit.prototype.render = function(context) {
      return context.response.render("" + context.name + "/" + context.view, {
        context: context
      });
    };
    Timbit.prototype.fetch = function(context, key, url, next) {
      if (next == null) {
        next = this.render;
      }
      return http.get(url, __bind(function(client) {
        var body;
        console.log("" + key + " STATUS: " + client.statusCode);
        body = "";
        client.on('data', __bind(function(chunk) {
          return body += chunk.toString();
        }, this));
        return client.on('end', __bind(function() {
          context[key] = JSON.parse(body);
          return next(context);
        }, this));
      }, this));
    };
    Timbit.prototype.eat = function(context) {
      return this.render(context);
    };
    return Timbit;
  })();
}).call(this);
